package gui;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;

import businessLogic.BookingManager;
import domain.Booking;
import domain.Offer;
import domain.Owner;
import domain.RuralHouse;

public class listOfBookingRequestsGUI extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private JTable table;
	private Owner own;
	private BookingManager bookM = new BookingManager();
	private DefaultTableModel tableModel;
	private Vector<Booking> bookings = new Vector<Booking>();

	/**
	 * Create the frame.
	 */
	public listOfBookingRequestsGUI(Owner own) {
		setTitle("Adding requests");
		this.own = own;
		try {

			init();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void init() throws Exception {
		setBounds(100, 100, 600, 450);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		this.bookings= this.bookM.getAllBookings(own);
		JLabel lblNewLabel = new JLabel();
		lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 27));
		lblNewLabel.setBounds(23, 41, 536, 33);
		contentPane.add(lblNewLabel);
		if (bookings.isEmpty())
			lblNewLabel
					.setText("There are not bookings to be confirmed or denied");
		else
			lblNewLabel.setText("List of bookings:");
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(new Rectangle(45, 305, 320, 116));
		scrollPane.setBounds(23, 113, 536, 271);
		contentPane.add(scrollPane);

		table = new JTable() {
			private static final long serialVersionUID = 1L;

			public boolean isCellEditable(int row, int column) {
				return false;
			};
		};
		scrollPane.setViewportView(table);
		tableModel = new DefaultTableModel(null, new String[] {
				"Booking Number", "Is paid", "Booking Date", "Telephone",
				"Offer" });

		// Maybe there is a better way to avoid interaction.
		// table.setEnabled(false);
		table.setModel(tableModel);

		JButton btnNewButton = new JButton("Confirm Booking");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (table.getRowCount() != 0 && table.getSelectedRow() != -1) {

				}
			}
		});
		btnNewButton.setBounds(88, 396, 169, 25);
		contentPane.add(btnNewButton);

		JButton btnDenyAddition = new JButton("Deny Booking");
		btnDenyAddition.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (table.getRowCount() != 0 && table.getSelectedRow() != -1) {

				}
			}
		});
		btnDenyAddition.setBounds(300, 396, 169, 25);
		contentPane.add(btnDenyAddition);
		Enumeration<Booking> en = this.bookings.elements();
		Booking book;
		while (en.hasMoreElements()) {
			book = en.nextElement();
			Vector<Object> row = new Vector<Object>();
			row.add(book.getBookNumber());
			row.add(book.isPaid());
			row.add(book.getBookDate());
			row.add(book.getTelephone());
			row.add(book.getOffer());
			tableModel.addRow(row);
		}

	}
}
